$fn=100;

h1=3;
h2=4;
ht=7;

wt=34;
w1=7;
w2=10;

l=15;

m=0.5;
screwDist=12.5;
screwRad=2;
screwRad2=1.5;
screwMnt=2;
screwMntDist=3;
asRad=5;
asLen=8;
asDepth = 1;

wl0=-wt/2;
wr0=wt/2;
wl1=wl0+w1;
wl2=wl0+w2;
wr1=wr0-w1;
wr2=wr0-w2;

c = 5;


for(i = [ 
	//[-20, 0, 0], 
	//[20, 0, 0],
	[0, 0, 0],
 	] ) 
{
	translate(i) 
		union()
		{
/*
			translate([ 0, 0, 25]) 
			BackPlate();

//			translate([0, (l + 5 ), 0]) 
			TopPlate();

			translate([ 0, 0, 10]) 
//			translate([0, -(l + 7), 0]) 
			Closure();

*/
			BackPlate();

			translate([0, (l + 5 ), 0]) 
			TopPlate();

			translate([0, -(l + 7), 0]) 
			Closure();


		}
};



module OutLine()
{
	translate([-wt/2, -l/2, ht/2])
	linear_extrude(height =ht, center = true, convexity = 0, twist = 0)
		polygon(
			points=[
				[0 , c],	[c, 0],		
				[wt-c, 0],  	[wt, c],		
				[wt, l - c],	[wt - c, l],
				[c, l], [0, l-c]
				], 
			paths=[[0, 1, 2, 3, 4,  5, 6, 7]]);
}

module TopPlate()
{
intersection() 
{
	OutLine();
	difference()
	{
/*
		translate([0, 0, 0])
			rotate([90, 0, 0])
				linear_extrude(height = l, center = true, convexity = 0, twist = 0)
					polygon(
						points=[
							[wl0, 0],	[wr0, 0],		[wr0, ht],		[wr2, ht],
							[wr1, h1],	[wl1, h1],		[wl2, ht], 		[wl0, ht], ], 
						paths=[[0, 1, 2, 3, 4, 5, 6, 7]]);
*/
		translate([  0, 0, ht/2]) cube([wt, l, ht], center=true);
		#translate([  0, 0, (ht+h2)/2]) cube([wt - (2*w2), l, h2], center=true);
		#translate([  screwDist, 0, -0.5]) cylinder(h=screwMntDist, r=screwMnt);
		#translate([ -screwDist, 0, -0.5]) cylinder(h=screwMntDist, r=screwMnt);
		#translate([  screwDist, 0, -0.5]) cylinder(h=asLen, r=screwRad);
		#translate([ -screwDist, 0, -0.5]) cylinder(h=asLen, r=screwRad);
		#translate([0, 0, -0.5])               cylinder(h=asLen, r=asRad);
	}
}
}

module BackPlate()
{
intersection() 
{
	OutLine();
	difference()
	{
		translate([0, 0, 0])
			rotate([90, 0, 0])
				linear_extrude(height = l, center = true, convexity = 0, twist = 0)
					polygon(
						points=[
							[wl0, 0],	[wr0, 0],		[wr0, h1],		[wl0, h1],
							], 
						paths=[[0, 1, 2, 3, 4, 5, 6, 7]]);
		#translate([  screwDist, 0, -0.5]) cylinder(h=h1 + 1, r1=screwRad, r2=screwRad2);
		#translate([ -screwDist, 0, -0.5]) cylinder(h=h1 + 1, r1=screwRad, r2=screwRad2);
		#translate([0, 0, -0.5])               cylinder(h=asLen, r=asRad);
	}
}
}

module Closure()
{
	translate([0, (l+h1)/2, (h1 - m)/2])
		cube([wt-(w1*2), h1, h1- m], center=true);
//		cube([wt-w1, h1, h1- m], center=true);

	difference()
	{
		union()
		{
		translate([  0, 0, (h1)/2]) cube([wt - (2*w2), l, h1], center=true);
//			translate([0, 0, -(ht-h1)-m])
//				rotate([90, 0, 0])
//					linear_extrude(height = l, center = true, convexity = 0, twist = 0)
//						polygon(
//							points=[	[wr2-m, ht],	[wr1-m, h1-m],	[wl1+m, h1-m],	[wl2+m, ht] ], 
//							paths=[[0,1, 2, 3]]);
//			#translate([0, 0, h1 ])              cylinder(h=m, r1=asRad, r2=asRad - 0.5,center=true);
		}
		#translate([0, 0, h1 ])          	     	cylinder(h=4*m, r=asRad, center=true);
	}
	#translate([0, 0, h1 - m])               cylinder(h = 2 * m, r1 = 1, r2 = 0.5, center = true); 
}
